//
//  CFGSocket.h
//
//  FGHelloDevice
//
//  Created by Francesco on 5/4/06.
//  Copyright 2006 Softech di Germinara Francesco. All rights reserved.
//
//  www.germinara.it - info@germinara.it
//

#import "theController.h"

@implementation theController

- (void) dealloc {
	[aFGSocket dealloc];
 	[super dealloc];
}

-(void) awakeFromNib{
[theIPAddress setStringValue:@"192.168.33.207"];
[thePort setStringValue:@"6001"];

aFGSocket=[[CFGSocket alloc] init];
[aFGSocket CreateSocket:[theIPAddress stringValue] withPort:[thePort intValue]];
[aFGSocket SetAllOutputStatus:FALSE];


}

-(void) startReadTimer:(NSTimeInterval)interval{
 aReadTimer=[NSTimer scheduledTimerWithTimeInterval:interval target:self selector:@selector(stepItFireMethod:) userInfo:nil repeats:YES];
}

- (void)stepItFireMethod:(NSTimer*)theTimer{
  [aFGSocket ReadStatus];
  [self setInputsStatus];
}

-(void)stopReadTimer{
 [aReadTimer invalidate];
}

- (IBAction)btnReadInputs:(id)sender{
  [aFGSocket ReadStatus];
  [self setInputsStatus];  
  NSLog([aFGSocket ShowInputStatus]);
}

- (IBAction)btnWriteOutputs:(id)sender{

 int nIndex=0;
 int nInputs=16;
 BOOL bitSts=FALSE;
 NSButton *aCell=nil;
 for(nIndex=0; nIndex<nInputs;nIndex++){
  int nCol=(nIndex % 8);
  int nRow=(int)(nIndex / 8);
  aCell=[theOutpus cellAtRow:nRow column:nCol];
  bitSts=[aCell state];
  [aFGSocket SetOutputStatus:nIndex withStatus:bitSts];
 }

 [aFGSocket SetOutput];
 [self setOutputsStatus];
}

- (IBAction)btnChkManualRead:(id)sender{
  if([chkManualRead state]==NSOnState)
   [self stopReadTimer];
  else 
   [self startReadTimer:0.1];
}


-(void) setInputsStatus{
 int nIndex=0;
 int nInputs=16;
 BOOL bitSts=FALSE;
 NSButton *aCell=nil;
 for(nIndex=0; nIndex<nInputs;nIndex++){
  bitSts=[aFGSocket GetInputStatus:nIndex useInvertedState:FALSE];
  int nCol=(nIndex % 8);
  int nRow=(int)(nIndex / 8);
  aCell=[theInputs cellAtRow:nRow column:nCol];
  [aCell setState:bitSts];
 }
}
 
 -(void) setOutputsStatus{
 int nIndex=0;
 int nInputs=16;
 BOOL bitSts=FALSE;
 NSButton *aCell=nil;
 for(nIndex=0; nIndex<nInputs;nIndex++){
  bitSts=[aFGSocket GetOutputStatus:nIndex];
  int nCol=(nIndex % 8);
  int nRow=(int)(nIndex / 8);
  aCell=[theOutpus cellAtRow:nRow column:nCol];
  [aCell setState:bitSts];
 }
}

 
@end

 
 
 
 
 
 
 
 